Last Comment Bug 461158 - js1_6/extensions/regress-456826.js: (Math|Date) is not defined
: js1_6/extensions/regress-456826.js: (Math|Date) is not defined
Status: VERIFIED FIXED
[sg:investigate] post 1.8-branch
: regression, testcase, verified1.9.0.9, verified1.9.1
Product: Core
Classification: Components
Component: JavaScript Engine (show other bugs)
: Trunk
: All All
: -- normal (vote)
: ---
Assigned To: Igor Bukanov
:
Mentors:
Depends on:
Blocks: js-propcache
  Show dependency treegraph
 
Reported: 2008-10-22 07:28 PDT by Bob Clary [:bc:]
Modified: 2009-04-21 13:59 PDT (History)
8 users (show)
sayrer: blocking1.9.1+
samuel.sidler+old: blocking1.9.0.9+
dveditz: wanted1.9.0.x+
dveditz: wanted1.8.1.x-
bob: in‑testsuite+
bob: in‑litmus-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
fix v1 (900 bytes, patch)
2008-11-26 14:56 PST, Igor Bukanov
brendan: review+
sayrer: approval1.9.1+
Details | Diff | Splinter Review
fix v1 (mq patch) (572 bytes, patch)
2008-11-26 16:35 PST, Igor Bukanov
igor: review+
Details | Diff | Splinter Review
Patch for the 1.9.0 branch (821 bytes, patch)
2009-03-17 14:50 PDT, Blake Kaplan (:mrbkap)
mrbkap: review+
samuel.sidler+old: approval1.9.0.9+
Details | Diff | Splinter Review

Description Bob Clary [:bc:] 2008-10-22 07:28:07 PDT
from bug 456826 comment 36.

./js1_6/extensions/regress-456826.js:93: Math is not defined
./js1_6/extensions/regress-456826.js:127: Date is not defined

either of these errors may occur depending on the build and shell options.

this regressed in http://hg.mozilla.org/mozilla-central/rev/62b8f8cd8b69

Igor@mir2.org date: Wed Apr 02 00:46:12 2008 -0700 summary: [Bug 423874] Allocating functions together with JSObject. r=brendan
Comment 1 Igor Bukanov 2008-11-26 14:45:13 PST
The regression is from bug 365851 and comes from the fact that js_FindPropertyHelper, http://hg.mozilla.org/mozilla-central/file/0d837275baca/js/src/jsobj.cpp#l3533 , does not propagate the error condition from js_LookupPropertyWithFlags . The latter returns -1 on errors and the code ignores that.

The reason the failure is associated with the bug 423874 is that bug altered the memory usage for the function objects. Given the restriction gcparam("maxBytes", 22000); from the test, that triggered the failure on the code path with errors.
Comment 2 Igor Bukanov 2008-11-26 14:56:55 PST
Created attachment 350229 [details] [diff] [review]
fix v1

The patch just adds the missing error check.
Comment 3 Igor Bukanov 2008-11-26 15:06:21 PST
Note on ./js1_6/extensions/regress-456826.js test: on 64-bit platform it fails with OOM and that should be OK. Alternatively, changing 22000 in gcparam("maxBytes", 22000); to 60000 on 64 bit should make it work.
Comment 4 Brendan Eich [:brendan] 2008-11-26 15:41:47 PST
Comment on attachment 350229 [details] [diff] [review]
fix v1

Whoops -- thanks for fixing.

/be
Comment 5 Robert Sayre 2008-11-26 15:51:29 PST
Comment on attachment 350229 [details] [diff] [review]
fix v1

a=sayrer, but it's already blocking
Comment 6 Igor Bukanov 2008-11-26 16:35:19 PST
Created attachment 350244 [details] [diff] [review]
fix v1 (mq patch)
Comment 7 Igor Bukanov 2008-11-26 16:42:13 PST
I marked the bug as restricted as it is not clear if there any hazards due to it.
Comment 8 Boris Zbarsky [:bz] 2008-11-26 20:06:23 PST
Pushed http://hg.mozilla.org/mozilla-central/rev/4c6331befc51
Comment 9 Bob Clary [:bc:] 2008-12-06 03:02:16 PST
verified fixed mozilla-central but not tracemonkey
Comment 10 Bob Clary [:bc:] 2009-01-22 03:26:15 PST
v 1.9.1, 1.9.2
Comment 11 Daniel Veditz [:dveditz] 2009-02-12 13:56:54 PST
Not needed for 1.8, wanted for 1.9.0 which contains the patch from bug 365851 that caused this. Don't know the potential security impacts of this.
Comment 12 Samuel Sidler (old account; do not CC) 2009-03-16 15:12:51 PDT
Igor: Can you please work up a 1.9.0-branch patch for this? Our code freeze for 1.9.0.8 is tomorrow and this blocks the release.
Comment 13 Blake Kaplan (:mrbkap) 2009-03-17 14:50:21 PDT
Created attachment 367870 [details] [diff] [review]
Patch for the 1.9.0 branch
Comment 14 Samuel Sidler (old account; do not CC) 2009-03-17 14:56:08 PDT
Comment on attachment 367870 [details] [diff] [review]
Patch for the 1.9.0 branch

Approved for 1.9.0.8. a=ss for release-drivers
Comment 15 Blake Kaplan (:mrbkap) 2009-03-17 14:59:39 PDT
Fixed on the 1.9.0 branch.
Comment 16 Bob Clary [:bc:] 2009-03-23 13:48:21 PDT
v 1.9.0

Note You need to log in before you can comment on or make changes to this bug.